// svg.easing.js 0.3 - Copyright (c) 2013 Wout Fierens - Licensed under the MIT license
// Based on Easing Equations (c) 2003 [Robert Penner](http://www.robertpenner.com/), all rights reserved.
SVG.easing={quadIn:function(e){return Math.pow(e,2)},quadOut:function(e){return-(Math.pow(e-1,2)-1)},quadInOut:function(e){if((e/=.5)<1)return.5*Math.pow(e,2);return-.5*((e-=2)*e-2)},cubicIn:function(e){return Math.pow(e,3)},cubicOut:function(e){return Math.pow(e-1,3)+1},cubicInOut:function(e){if((e/=.5)<1)return.5*Math.pow(e,3);return.5*(Math.pow(e-2,3)+2)},quartIn:function(e){return Math.pow(e,4)},quartOut:function(e){return-(Math.pow(e-1,4)-1)},quartInOut:function(e){if((e/=.5)<1)return.5*Math.pow(e,4);return-.5*((e-=2)*Math.pow(e,3)-2)},quintIn:function(e){return Math.pow(e,5)},quintOut:function(e){return Math.pow(e-1,5)+1},quintInOut:function(e){if((e/=.5)<1)return.5*Math.pow(e,5);return.5*(Math.pow(e-2,5)+2)},sineIn:function(e){return-Math.cos(e*(Math.PI/2))+1},sineOut:function(e){return Math.sin(e*(Math.PI/2))},sineInOut:function(e){return-.5*(Math.cos(Math.PI*e)-1)},expoIn:function(e){return e==0?0:Math.pow(2,10*(e-1))},expoOut:function(e){return e==1?1:-Math.pow(2,-10*e)+1},expoInOut:function(e){if(e==0)return 0;if(e==1)return 1;if((e/=.5)<1)return.5*Math.pow(2,10*(e-1));return.5*(-Math.pow(2,-10*--e)+2)},circIn:function(e){return-(Math.sqrt(1-e*e)-1)},circOut:function(e){return Math.sqrt(1-Math.pow(e-1,2))},circInOut:function(e){if((e/=.5)<1)return-.5*(Math.sqrt(1-e*e)-1);return.5*(Math.sqrt(1-(e-=2)*e)+1)},backIn:function(e){var t=1.70158;return e*e*((t+1)*e-t)},backOut:function(e){e=e-1;var t=1.70158;return e*e*((t+1)*e+t)+1},backInOut:function(e){var t=1.70158;if((e/=.5)<1)return.5*e*e*(((t*=1.525)+1)*e-t);return.5*((e-=2)*e*(((t*=1.525)+1)*e+t)+2)},swingFromTo:function(e){var t=1.70158;return(e/=.5)<1?.5*e*e*(((t*=1.525)+1)*e-t):.5*((e-=2)*e*(((t*=1.525)+1)*e+t)+2)},swingFrom:function(e){var t=1.70158;return e*e*((t+1)*e-t)},swingTo:function(e){var t=1.70158;return(e-=1)*e*((t+1)*e+t)+1},bounce:function(e){var t=7.5625,n=2.75,r;if(e<1/n){r=t*e*e}else{if(e<2/n){e-=1.5/n;r=t*e*e+.75}else{if(e<2.5/n){e-=2.25/n;r=t*e*e+.9375}else{e-=2.625/n;r=t*e*e+.984375}}}return r},bounceOut:function(e){if(e<1/2.75){return 7.5625*e*e}else if(e<2/2.75){return 7.5625*(e-=1.5/2.75)*e+.75}else if(e<2.5/2.75){return 7.5625*(e-=2.25/2.75)*e+.9375}else{return 7.5625*(e-=2.625/2.75)*e+.984375}},elastic:function(e){if(e==!!e)return e;return Math.pow(2,-10*e)*Math.sin((e-.075)*2*Math.PI/.3)+1}}